hgeditor
author Matt Mackall <mpm@selenic.com>
Mon, 11 Jul 2005 21:54:37 -0800
changeset 683 104d2aee3b44
parent 682 d6723636c172
child 684 4ccf3de52989
permissions -rwxr-xr-x
Revert hgeditor change to manifest bits -----BEGIN PGP SIGNED MESSAGE----- Hash: SHA1 Revert hgeditor change to manifest bits I'd rather have a blank line at the top. This code primarily exists to show possible methods of signing changesets so I'm not very concerned about conciseness or performance. I should probably have all the signing commented out or disabled by default. manifest hash: 764da8d65bdaf9b45c7e3efd6cd2b4ee70979417 -----BEGIN PGP SIGNATURE----- Version: GnuPG v1.4.0 (GNU/Linux) iD8DBQFC01sdywK+sNU5EO8RAr2BAJ9Uq0XberFrYyehvmoKgE8p/j0XFQCdFPJr DPDMbKeBHwK/yMiileBFW8o= =DvnD -----END PGP SIGNATURE-----

#!/bin/sh
#
# This is an example of using HGEDITOR to automate the signing of
# commits and so on.

T1=""; T2=""
cleanup_exit() {
    rm -f "$T1" "$T2"
    exit $1
}

# If you want to pass your favourite editor some other parameters
# only for Mercurial, modify this:
case "${EDITOR:=vi}" in
    emacs)
        EDITOR="$EDITOR -nw"
        ;;
    gvim|vim)
        EDITOR="$EDITOR -f -o"
        ;;
esac

if grep -q "^HG: merge resolve" "$1" ; then
    # we don't sign merges
    exec $EDITOR "$1"
else
    # Remove temporary files even if we get interrupted
    trap "cleanup_exit 255" TERM KILL INT QUIT ABRT
    T1=`mktemp`; T2=`mktemp`
    MANIFEST=`grep '^HG: manifest hash' "$1" | cut -b 19-`

    echo -e "\n\nmanifest hash: $MANIFEST" >> "$T1"
    grep -vE '^(HG: manifest hash .*)?$' "$1" >> "$T1"
    (
        cd "`hg root`"
        grep '^HG: changed' "$1" | cut -b 13- | while read changed; do
            hg diff "$changed" >> "$T2"
        done
    )

    CHECKSUM=`md5sum "$T1"`
    $EDITOR "$T1" "$T2" || cleanup_exit $?
    echo "$CHECKSUM" | md5sum -c 2>/dev/null && cleanup_exit 13
    {
        head -n 1 "$T1"
        echo
        grep -v "^HG:" "$T1" | gpg -t -a -u "${HGUSER}" --clearsign
    } > "$T2" && mv "$T2" "$1"
    cleanup_exit $?
fi